﻿/**
 * ...
 * @author Georg Graf
 */

package com.georg
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldType;
	
	public class Stepper extends Sprite
	{
		private var text:TextField;
		private var up:Sprite;
		private var down:Sprite;
		
		private var _value:int;
		
		public function Stepper(start:int = 0) 
		{
			super();
			
			createText();
			createUp();
			createDown();
			
			value = start;
		}
		
		private function createText():void
		{
			graphics.beginFill(0xf28729, .5);
			graphics.drawRect(0, 0, 44, 21);
			graphics.endFill();
			
			text = new TextField();
			text.type = TextFieldType.INPUT;
			text.defaultTextFormat = new TextFormat("Arial", 12, 0);
			text.width = 30;
			text.text = value.toString();
			text.x = 5;
			text.y = 1;
			text.addEventListener(KeyboardEvent.KEY_DOWN, enterPressed);
			addChild(text);
		}
		
		private function createUp():void
		{
			up = new Sprite();
			up.graphics.beginFill(0xf28729);
			up.graphics.drawRect(0, 0, 14, 10);
			up.graphics.endFill();
			
			up.graphics.beginFill(0xffae00);
			up.graphics.moveTo(7, 2);
			up.graphics.lineTo(10, 8);
			up.graphics.lineTo(4, 8);
			up.graphics.lineTo(7, 2);
			up.graphics.endFill();
			
			up.buttonMode = true;
			up.x = 30;
			up.addEventListener(MouseEvent.CLICK, upClicked);
			addChild(up);
		}
		private function createDown():void
		{
			down = new Sprite();
			down.graphics.beginFill(0xf28729);
			down.graphics.drawRect(0, 0, 14, 10);
			down.graphics.endFill();
			
			down.graphics.beginFill(0xffae00);
			down.graphics.moveTo(7, 8);
			down.graphics.lineTo(10, 2);
			down.graphics.lineTo(4, 2);
			down.graphics.lineTo(7, 8);
			down.graphics.endFill();
			
			down.buttonMode = true;
			down.x = 30;
			down.y = 11;
			down.addEventListener(MouseEvent.CLICK, downClicked);
			addChild(down);
		}
		
		private function upClicked(e:MouseEvent):void { value++; }
		private function downClicked(e:MouseEvent):void { value--; }
		private function enterPressed(e:KeyboardEvent):void 
		{ 
			if (e.keyCode == 13)
			{
				var newVal:int = int(text.text);
				
				if (newVal > 0)
					value = newVal; 
			}
		}
	
		
		public function get value():int { return _value; }
		public function set value(v:int):void
		{
			if (v > 0) 
			{
				_value = v;
				text.text = _value.toString();
				
				dispatchEvent(new Event(Event.CHANGE));
			}
		}
	}
}