﻿/**
 * ...
 * @author Georg Graf
 */

package com.georg.tools
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.Timer;
	import flash.utils.getTimer;
	 
	public class FPSCounter extends TextField
	{
		// time save vars
		private var startTick:Number;
		private var tick:Number;
		// frame save vars
		private var numFrames:Number;
		private var frames:Number;
		// reset timer var
		private var timer:Timer;
		
		// calc vars
		private var startDiff:Number;
		private var diff:Number;
	  
		public function FPSCounter()
		{
			super();
			
			timer = new Timer(1000, 0);
			timer.addEventListener(TimerEvent.TIMER, resetFrames);
			
			defaultTextFormat = new TextFormat("Arial", 12, 0xFFFFFF);
			mouseEnabled = false;
		}
		
		private function resetFrames(e:TimerEvent):void 
		{
			// reset only current fps
			startTick  = getTimer();
			frames = 0;
		}
		
		public function start():void 
		{ 
			numFrames = 0;
			frames = 0;
			startTick  = getTimer();
			tick = getTimer();
			timer.start();
			addEventListener(Event.ENTER_FRAME, onEnterFrame); 
		}
			
		public function stop():void 
		{ 
			removeEventListener(Event.ENTER_FRAME, onEnterFrame); 
			timer.stop();
		} 
	  
		public function onEnterFrame(event:Event):void
		{
			++numFrames;
			++frames;
			
			startDiff = (getTimer() - startTick) * .001;
			diff = (getTimer() - tick) * .001;
			
			text = Math.floor(frames / startDiff) + " FPS " + Math.floor(numFrames / diff) + " AV";
		}
	 }
}